package com.el.ui.graphicserver.provider.entity;

import java.awt.image.BufferedImage;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.lang.annotation.Annotation;
import java.lang.reflect.Type;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.imageio.ImageIO;
import javax.ws.rs.WebApplicationException;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.MultivaluedMap;
import javax.ws.rs.ext.MessageBodyWriter;
import javax.ws.rs.ext.Provider;

@Provider
public class ImageProvider implements MessageBodyWriter<BufferedImage> {

    public ImageProvider() {
    }

    @Override
    public boolean isWriteable(Class<?> type, Type genericType, Annotation[] annotations) {
        return BufferedImage.class.isAssignableFrom(type);
    }

    @Override
    public long getSize(BufferedImage image) {
        // XXX is there some way to avoid doing this twice?
        // XXX when is this even called?
        ByteArrayOutputStream bas = new ByteArrayOutputStream();
        try {
            ImageIO.write(image, "png", bas);
        } catch (Exception e) {
            Logger.getLogger(ImageProvider.class.getName()).log(Level.SEVERE, null, e);
        }
        return bas.size();
    }

    @Override
    public void writeTo(BufferedImage image, Class<?> type, Type genericType, Annotation[] annotations,
            MediaType mediaType, MultivaluedMap<String, Object> httpHeaders, OutputStream entityStream)
            throws IOException, WebApplicationException {
        ImageIO.write(image, "png", entityStream);
    }
}
